unit MainForm_U;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LazSerial, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, LazSynaSer;

type

  { TMainForm }

  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    EditDevice: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Memo1: TMemo;
    Serial1: TLazSerial;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Serial1RxData(Sender: TObject);
    procedure Serial1Status(Sender: TObject; Reason: THookSerialReason;
      const Value: string);
  private
    procedure Parse(str: string);
  public

  end;

var
  CurPos: integer;
  FTempStr: string;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.Parse(str: string);
var
  fL: TStringList;
  i: integer;
begin
  fL := TStringList.Create;
  try
    fL.Delimiter := ',';
    fL.StrictDelimiter := True;
    fL.DelimitedText := str;
    for i := 0 to fl.Count - 1 do
      if Pos('CONFIG', str) > 0 then
      begin
        Label12.Caption := fl[1];
        ComboBox1.Text := fL[1];
        Label13.Caption := fl[2];
        Edit1.Text := fL[2];
        Label16.Caption := fl[3];
        Edit4.Text := fL[3];
        Label14.Caption := fl[4];
        Edit2.Text := fL[4];
        Label15.Caption := fl[5];
        Edit3.Text := fL[5];
        Label9.Caption := fl[6];
        Label10.Caption := fl[7];
        Label11.Caption := fl[8];
      end;
    if Pos('NETWORKS', str) > 0 then
    begin
      ComboBox1.Items.Assign(fL);
      ComboBox1.Items.Delete(0);
      ComboBox1.Items.Delete(i-1);
      Label23.Caption:=IntToStr(ComboBox1.Items.Count);

    end;
  finally
    fL.Free
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Serial1.ShowSetupDialog;
  EditDevice.Text := Serial1.Device;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Serial1.Device := EditDevice.Text;
  Serial1.Open;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  Serial1.WriteData('SCAN' + char(13) + char(10));
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  Serial1.WriteData('SET_SSID' + ' ' + ComboBox1.Text + char(13) + char(10));
  Serial1.WriteData('SET_PASS' + ' ' + Edit1.Text + char(13) + char(10));
  Serial1.WriteData('SET_CALL' + ' ' + Edit4.Text + char(13) + char(10));
  Serial1.WriteData('SET_HOST' + ' ' + Edit2.Text + char(13) + char(10));
  Serial1.WriteData('SET_PORT' + ' ' + Edit3.Text + char(13) + char(10));
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
  Serial1.WriteData('RESTART' + char(13) + char(10));
end;

procedure TMainForm.Button7Click(Sender: TObject);
begin
  Serial1.WriteData('??' + char(13) + char(10));
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  Serial1.WriteData('CONNECT_WIFI' + char(13) + char(10));
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  Serial1.WriteData('CONNECT_DX' + char(13) + char(10));
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Label9.Caption := '';
  Label10.Caption := '';
  Label11.Caption := '';
  Label12.Caption := '';
  Label13.Caption := '';
  Label14.Caption := '';
  Label15.Caption := '';
  Label16.Caption := '';
  Label23.Caption := '0';
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Serial1.Close;
end;

procedure TMainForm.Serial1RxData(Sender: TObject);
var
  Str: string;
begin
  Str := Serial1.ReadData;
  CurPos := Pos(char(10), Str);
  if CurPos = 0 then
  begin
    FTempStr := FTempStr + Str;
  end
  else
  begin
    FTempStr := FTempStr + Copy(Str, 1, CurPos - 1);
    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Add(FtempStr);
    Memo1.Lines.EndUpdate;
    Memo1.SelStart := Length(Memo1.Lines.Text) - 1;
    Memo1.SelLength := 0;
    Parse(FtempStr);
    FTempStr := Copy(Str, CurPos + 1, Length(Str) - CurPos);
  end;

end;

procedure TMainForm.Serial1Status(Sender: TObject; Reason: THookSerialReason;
  const Value: string);
begin
  case Reason of
    HR_SerialClose: StatusBar1.SimpleText := 'Port ' + Value + ' closed';
    HR_Connect: StatusBar1.SimpleText := 'Port ' + Value + ' connected';
    HR_CanRead: StatusBar1.SimpleText := 'CanRead : ' + Value;
    HR_CanWrite: StatusBar1.SimpleText := 'CanWrite : ' + Value;
    HR_ReadCount: StatusBar1.SimpleText := 'ReadCount : ' + Value;
    HR_WriteCount: StatusBar1.SimpleText := 'WriteCount : ' + Value;
    HR_Wait: StatusBar1.SimpleText := 'Wait : ' + Value;

  end;

end;

end.
